diff --git a/lisp/isearch.el b/lisp/isearch.el
index 0879f948cf..18f1946a27 100644
--- a/lisp/isearch.el
+++ b/lisp/isearch.el
@@ -87,12 +87,14 @@ search-slow-window-lines
 Negative means put the slow search window at the top (normally it's at bottom)
 and the value is minus the number of lines."
   :type 'integer)
+(make-obsolete-variable 'search-slow-window-lines "no longer used." "28.1")
 
 (defcustom search-slow-speed 1200
   "Highest terminal speed at which to use \"slow\" style incremental search.
 This is the style where a one-line window is created to show the line
 that the search has reached."
   :type 'integer)
+(make-obsolete-variable 'search-slow-speed "no longer used." "28.1")
 
 (defcustom search-upper-case 'not-yanks
   "If non-nil, upper case chars disable case fold searching.
@@ -926,11 +928,13 @@ isearch-original-minibuffer-message-timeout
 
 (defvar isearch-adjusted nil)
 (defvar isearch-slow-terminal-mode nil)
+(make-obsolete-variable 'isearch-slow-terminal-mode "no longer used." "28.1")
 ;; If t, using a small window.
 (defvar isearch-small-window nil)
+(make-obsolete-variable 'isearch-small-window "no longer used." "28.1")
 (defvar isearch-opoint 0)
-;; The window configuration active at the beginning of the search.
 (defvar isearch-window-configuration nil)
+(make-obsolete-variable 'isearch-window-configuration "no longer used." "28.1")
 
 ;; Flag to indicate a yank occurred, so don't move the cursor.
 (defvar isearch-yank-flag nil)
@@ -1218,13 +1222,8 @@ isearch-mode
 	isearch-adjusted nil
 	isearch-yank-flag nil
 	isearch-error nil
-	isearch-slow-terminal-mode (and (<= baud-rate search-slow-speed)
-					(> (window-height)
-					   (* 4
-					      (abs search-slow-window-lines))))
-	isearch-other-end nil
-	isearch-small-window nil
-	isearch-just-started t
+        isearch-other-end nil
+        isearch-just-started t
 	isearch-start-hscroll (window-hscroll)
 	isearch-match-data nil
 
@@ -1258,8 +1257,6 @@ isearch-mode
   (setq input-method-function nil)
 
   (looking-at "")
-  (setq isearch-window-configuration
-	(if isearch-slow-terminal-mode (current-window-configuration) nil))
 
   ;; Maybe make minibuffer frame visible and/or raise it.
   (let ((frame (window-frame (minibuffer-window))))
@@ -1321,38 +1318,19 @@ isearch-update
       (progn
         (if (not (input-pending-p))
           (funcall (or isearch-message-function #'isearch-message)))
-        (if (and isearch-slow-terminal-mode
-                 (not (or isearch-small-window
-                          (pos-visible-in-window-group-p))))
-            (let ((found-point (point)))
-              (setq isearch-small-window t)
-              (move-to-window-line 0)
-              (let ((window-min-height 1))
-                (split-window nil (if (< search-slow-window-lines 0)
-                                      (1+ (- search-slow-window-lines))
-                                    (- (window-height)
-                                       (1+ search-slow-window-lines)))))
-              (if (< search-slow-window-lines 0)
-                  (progn (vertical-motion (- 1 search-slow-window-lines))
-                         (set-window-start (next-window) (point))
-                         (set-window-hscroll (next-window)
-                                             (window-hscroll))
-                         (set-window-hscroll (selected-window) 0))
-                (other-window 1))
-              (goto-char found-point))
-	  ;; Keep same hscrolling as at the start of the search when possible
-	  (let ((current-scroll (window-hscroll))
-		visible-p)
-	    (set-window-hscroll (selected-window) isearch-start-hscroll)
-	    (setq visible-p (pos-visible-in-window-group-p nil nil t))
-	    (if (or (not visible-p)
-		    ;; When point is not visible because of hscroll,
-		    ;; pos-visible-in-window-group-p returns non-nil, but
-		    ;; the X coordinate it returns is 1 pixel beyond
-		    ;; the last visible one.
-		    (>= (car visible-p)
-                        (* (window-max-chars-per-line) (frame-char-width))))
-		(set-window-hscroll (selected-window) current-scroll))))
+        ;; Keep same hscrolling as at the start of the search when possible
+        (let ((current-scroll (window-hscroll))
+              visible-p)
+          (set-window-hscroll (selected-window) isearch-start-hscroll)
+          (setq visible-p (pos-visible-in-window-group-p nil nil t))
+          (if (or (not visible-p)
+                  ;; When point is not visible because of hscroll,
+                  ;; pos-visible-in-window-group-p returns non-nil, but
+                  ;; the X coordinate it returns is 1 pixel beyond
+                  ;; the last visible one.
+                  (>= (car visible-p)
+                      (* (window-max-chars-per-line) (frame-char-width))))
+              (set-window-hscroll (selected-window) current-scroll)))
 	(if isearch-other-end
             (if (< isearch-other-end (point)) ; isearch-forward?
                 (isearch-highlight isearch-other-end (point) isearch-match-data)
@@ -1400,16 +1378,7 @@ isearch-done
   (lazy-highlight-cleanup lazy-highlight-cleanup)
   (setq isearch-lazy-highlight-last-string nil)
   (let ((found-start (window-group-start))
-	(found-point (point)))
-    (when isearch-window-configuration
-      (set-window-configuration isearch-window-configuration)
-      (if isearch-small-window
-	  (goto-char found-point)
-	;; set-window-configuration clobbers window-start; restore it.
-	;; This has an annoying side effect of clearing the last_modiff
-	;; field of the window, which can cause unwanted scrolling,
-	;; so don't do it unless truly necessary.
-	(set-window-group-start (selected-window) found-start t))))
+        (found-point (point))))
 
   (setq isearch-mode nil)
   (if isearch-input-method-local-p
@@ -1646,11 +1615,7 @@ with-isearch-suspended
   ;;; shorter period, ending before the next isearch-search.
   ;;; But there doesn't seem to be a real bug, so let's not risk it now.
 	      (isearch-opoint isearch-opoint)
-	      (isearch-slow-terminal-mode isearch-slow-terminal-mode)
-	      (isearch-small-window isearch-small-window)
-	      (isearch-recursive-edit isearch-recursive-edit)
-	      ;; Save current configuration so we can restore it here.
-	      (isearch-window-configuration (current-window-configuration))
+              (isearch-recursive-edit isearch-recursive-edit)
 
 	      ;; This could protect the index of the search rings,
 	      ;; but we can't reliably count the number of typed M-p
